import math
from tkinter import *
from RNGen import RNp2to191
from submodule import *


def myLog(v):
    if v < 1.0e-323:
        return -743.747
    else:
        return math.log(v)


def LogL(Nij, Kx, Ky, Cx, Cy, rho):
    v = 0.0
    for i in range(Kx):
        for j in range(Ky):
            if i == 0:
                if j == 0:
                    v += Nij[i][j] * myLog(Pnn(Cx[0], Cy[0], rho))
                elif j == (Ky - 1):
                    v += Nij[i][j] * myLog(Pnp(Cx[0], Cy[Ky - 2], rho))
                else:
                    v += Nij[i][j] * myLog(Pnc(Cx[0], Cy[j - 1], Cy[j], rho))
            elif i == Kx - 1:
                if j == 0:
                    v += Nij[i][j] * myLog(Ppn(Cx[Kx - 2], Cy[0], rho))
                elif j == Ky - 1:
                    v += Nij[i][j] * myLog(Ppp(Cx[Kx - 2], Cy[Ky - 2], rho))
                else:
                    v += Nij[i][j] * myLog(Ppc(Cx[Kx - 2], Cy[j - 1], Cy[j], rho))
            else:
                if j == 0:
                    v += Nij[i][j] * myLog(Pcn(Cx[i - 1], Cx[i], Cy[0], rho))
                elif j == Ky - 1:
                    v += Nij[i][j] * myLog(Pcp(Cx[i - 1], Cx[i], Cy[Ky - 2], rho))
                else:
                    v += Nij[i][j] * myLog(Pcc(Cx[i - 1], Cx[i], Cy[j - 1], Cy[j], rho))

    return v



def EstGrid( params ):
    """
            params = {'Nij': 'Kx': 'Ky': 'Cx', 'Cy':
                        'grid_x': 'p_start': 'p_end': }

    """
    root = Tk()
    root.title('Grid Method')
    cnvs = Canvas(root, width = 500, height = 150, background = '#000055')
    cnvs.pack()

    Nij = params['Nij']
    Kx = params['Kx']
    Ky = params['Ky']
    Cx = params['Cx']
    Cy = params['Cy']
    grid_x = params['grid_x']
    p_start = params['p_start']
    p_end = params['p_end']

    grid_p = []
    for i in range(p_start, p_end + 1):
        if (i == p_start) or (i % 50 == 0):
            msg = '{0}/<{1} - {2}>'.format(i, p_start, p_end)
            print(msg)
            cnvs.create_rectangle(0, 0, 500, 150, outline = '#000055', fill = '#000055')
            cnvs.create_text(250, 75, text = msg, font = ('', 15), fill = '#FFFFFF')
            cnvs.update()
        rho = grid_x[i]
        v =  LogL(Nij, Kx, Ky, Cx, Cy, rho) 
        grid_p.append(v)
                                  

    root.destroy()

    return grid_p



